package com.sun.org.apache.xerces.internal.impl.xs.identity;

import com.sun.org.apache.xerces.internal.xs.AttributePSVI;
import com.sun.org.apache.xerces.internal.xni.XMLAttributes;
import com.sun.org.apache.xerces.internal.xs.ShortList;
import com.sun.org.apache.xerces.internal.xs.XSTypeDefinition;
import com.sun.org.apache.xerces.internal.xni.QName;
import com.sun.org.apache.xerces.internal.util.IntStack;
import com.sun.org.apache.xerces.internal.impl.xpath.XPath;

public class XPathMatcher
{
    protected static final boolean DEBUG_ALL = false;
    protected static final boolean DEBUG_METHODS = false;
    protected static final boolean DEBUG_METHODS2 = false;
    protected static final boolean DEBUG_METHODS3 = false;
    protected static final boolean DEBUG_MATCH = false;
    protected static final boolean DEBUG_STACK = false;
    protected static final boolean DEBUG_ANY = false;
    protected static final int MATCHED = 1;
    protected static final int MATCHED_ATTRIBUTE = 3;
    protected static final int MATCHED_DESCENDANT = 5;
    protected static final int MATCHED_DESCENDANT_PREVIOUS = 13;
    private XPath.LocationPath[] fLocationPaths;
    private int[] fMatched;
    protected Object fMatchedString;
    private IntStack[] fStepIndexes;
    private int[] fCurrentStep;
    private int[] fNoMatchDepth;
    final QName fQName;
    
    public XPathMatcher(XPath xpath) {
        this.fQName = new QName();
        this.fLocationPaths = xpath.getLocationPaths();
        this.fStepIndexes = new IntStack[this.fLocationPaths.length];
        for (int i = 0; i < this.fStepIndexes.length; ++i) {
            this.fStepIndexes[i] = new IntStack();
        }
        this.fCurrentStep = new int[this.fLocationPaths.length];
        this.fNoMatchDepth = new int[this.fLocationPaths.length];
        this.fMatched = new int[this.fLocationPaths.length];
    }
    
    public boolean isMatched() {
        int i = 0;
        while (i < this.fLocationPaths.length) {
            if ((this.fMatched[i] & 0x1) == 0x1 && (this.fMatched[i] & 0xD) != 0xD && (this.fNoMatchDepth[i] == 0 || (this.fMatched[i] & 0x5) == 0x5)) {
                return true;
            }
            ++i;
        }
        return false;
    }
    
    protected void handleContent(XSTypeDefinition type, boolean nillable, Object value, short valueType, ShortList itemValueType) {
    }
    
    protected void matched(Object actualValue, short valueType, ShortList itemValueType, boolean isNil) {
    }
    
    public void startDocumentFragment() {
        this.fMatchedString = null;
        for (int i = 0; i < this.fLocationPaths.length; this.fCurrentStep[i] = 0, this.fNoMatchDepth[i] = 0, this.fMatched[i] = 0, ++i) {
            this.fStepIndexes[i].clear();
        }
    }
    
    public void startElement(QName element, XMLAttributes attributes) {
        for (int i = 0; i < this.fLocationPaths.length; ++i) {
            int startStep = this.fCurrentStep[i];
            this.fStepIndexes[i].push(startStep);
            if ((this.fMatched[i] & 0x5) == 0x1 || this.fNoMatchDepth[i] > 0) {
                int[] fNoMatchDepth4 = this.fNoMatchDepth;
                int n8 = i;
                ++fNoMatchDepth4[n8];
            }
            else {
                if ((this.fMatched[i] & 0x5) == 0x5) {
                    this.fMatched[i] = 13;
                }
                XPath.Step[] steps = this.fLocationPaths[i].steps;
                while (this.fCurrentStep[i] < steps.length && steps[this.fCurrentStep[i]].axis.type == 3) {
                    int[] fCurrentStep = this.fCurrentStep;
                    int n = i;
                    ++fCurrentStep[n];
                }
                if (this.fCurrentStep[i] == steps.length) {
                    this.fMatched[i] = 1;
                }
                else {
                    int descendantStep = this.fCurrentStep[i];
                    while (this.fCurrentStep[i] < steps.length && steps[this.fCurrentStep[i]].axis.type == 4) {
                        int[] fCurrentStep2 = this.fCurrentStep;
                        int n2 = i;
                        ++fCurrentStep2[n2];
                    }
                    boolean sawDescendant = this.fCurrentStep[i] > descendantStep;
                    if (this.fCurrentStep[i] == steps.length) {
                        int[] fNoMatchDepth3 = this.fNoMatchDepth;
                        int n7 = i;
                        ++fNoMatchDepth3[n7];
                    }
                    else {
                        if ((this.fCurrentStep[i] == startStep || this.fCurrentStep[i] > descendantStep) && steps[this.fCurrentStep[i]].axis.type == 1) {
                            XPath.Step step = steps[this.fCurrentStep[i]];
                            XPath.NodeTest nodeTest = step.nodeTest;
                            if (nodeTest.type == 1 && !nodeTest.name.equals(element)) {
                                if (this.fCurrentStep[i] > descendantStep) {
                                    this.fCurrentStep[i] = descendantStep;
                                    continue;
                                }
                                int[] fNoMatchDepth = this.fNoMatchDepth;
                                int n4 = i;
                                ++fNoMatchDepth[n4];
                                continue;
                            }
                            else {
                                int[] fCurrentStep3 = this.fCurrentStep;
                                int n3 = i;
                                ++fCurrentStep3[n3];
                            }
                        }
                        if (this.fCurrentStep[i] == steps.length) {
                            if (sawDescendant) {
                                this.fCurrentStep[i] = descendantStep;
                                this.fMatched[i] = 5;
                            }
                            else {
                                this.fMatched[i] = 1;
                            }
                        }
                        else if (this.fCurrentStep[i] < steps.length && steps[this.fCurrentStep[i]].axis.type == 2) {
                            int attrCount = attributes.getLength();
                            if (attrCount > 0) {
                                XPath.NodeTest nodeTest = steps[this.fCurrentStep[i]].nodeTest;
                                int aIndex = 0;
                                while (aIndex < attrCount) {
                                    attributes.getName(aIndex, this.fQName);
                                    if (nodeTest.type != 1 || nodeTest.name.equals(this.fQName)) {
                                        int[] fCurrentStep4 = this.fCurrentStep;
                                        int n5 = i;
                                        ++fCurrentStep4[n5];
                                        if (this.fCurrentStep[i] == steps.length) {
                                            this.fMatched[i] = 3;
                                            int j;
                                            for (j = 0; j < i && (this.fMatched[j] & 0x1) != 0x1; ++j) {}
                                            if (j == i) {
                                                AttributePSVI attrPSVI = (AttributePSVI)attributes.getAugmentations(aIndex).getItem("ATTRIBUTE_PSVI");
                                                this.matched(this.fMatchedString = attrPSVI.getActualNormalizedValue(), attrPSVI.getActualNormalizedValueType(), attrPSVI.getItemValueTypes(), false);
                                            }
                                            break;
                                        }
                                        else {
                                            break;
                                        }
                                    }
                                    else {
                                        ++aIndex;
                                    }
                                }
                            }
                            if ((this.fMatched[i] & 0x1) != 0x1) {
                                if (this.fCurrentStep[i] > descendantStep) {
                                    this.fCurrentStep[i] = descendantStep;
                                }
                                else {
                                    int[] fNoMatchDepth2 = this.fNoMatchDepth;
                                    int n6 = i;
                                    ++fNoMatchDepth2[n6];
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    
    public void endElement(QName element, XSTypeDefinition type, boolean nillable, Object value, short valueType, ShortList itemValueType) {
        for (int i = 0; i < this.fLocationPaths.length; ++i) {
            this.fCurrentStep[i] = this.fStepIndexes[i].pop();
            if (this.fNoMatchDepth[i] > 0) {
                int[] fNoMatchDepth = this.fNoMatchDepth;
                int n = i;
                --fNoMatchDepth[n];
            }
            else {
                int j;
                for (j = 0; j < i && (this.fMatched[j] & 0x1) != 0x1; ++j) {}
                if (j >= i && this.fMatched[j] != 0 && (this.fMatched[j] & 0x3) != 0x3) {
                    this.handleContent(type, nillable, value, valueType, itemValueType);
                    this.fMatched[i] = 0;
                }
            }
        }
    }
    
    @Override
    public String toString() {
        StringBuffer str = new StringBuffer();
        String s = super.toString();
        int index2 = s.lastIndexOf(46);
        if (index2 != -1) {
            s = s.substring(index2 + 1);
        }
        str.append(s);
        for (int i = 0; i < this.fLocationPaths.length; ++i) {
            str.append('[');
            XPath.Step[] steps = this.fLocationPaths[i].steps;
            for (int j = 0; j < steps.length; ++j) {
                if (j == this.fCurrentStep[i]) {
                    str.append('^');
                }
                str.append(steps[j].toString());
                if (j < steps.length - 1) {
                    str.append('/');
                }
            }
            if (this.fCurrentStep[i] == steps.length) {
                str.append('^');
            }
            str.append(']');
            str.append(',');
        }
        return str.toString();
    }
    
    private String normalize(String s) {
        StringBuffer str = new StringBuffer();
        for (int length = s.length(), i = 0; i < length; ++i) {
            char c = s.charAt(i);
            switch (c) {
                case '\n': {
                    str.append("\\n");
                    break;
                }
                default: {
                    str.append(c);
                    break;
                }
            }
        }
        return str.toString();
    }
}
